给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。 你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。 示例: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1] 来源:力扣(LeetCode) 链接:https://leetcode-cn.com/problems/two-sum 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
public int[] twoSum(int[] nums, int target) { }
思路 还是循环遍历 暴力处理
class Solution { public int[] twoSum(int[] nums, int target) { int[] in = new int[2]; for (int i = 0; i < nums.length; i++) { for (int j = i+1; j < nums.length ; j++) { if (nums[i] + nums[j] == target) { in[0] = i; in[1] = j; return in; } } } return null; } }
官方给了另一种思路 用hashmap
class Solution { public int[] twoSum(int[] nums, int target) { Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>(); for (int i = 0; i < nums.length; ++i) { if (hashtable.containsKey(target - nums[i])) { return new int[]{hashtable.get(target - nums[i]), i}; } hashtable.put(nums[i], i); } return new int[0]; } }